;gdt.s -- contain global descriptor table setup code

global gdt_flush, tss_flush

;void gdt_flush (uint32_t);
gdt_flush:
	mov eax, [esp+4]
	lgdt [eax];

	mov ax, 0x10	;offset in the gdt to our data segment
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax
	mov ss, ax
	jmp 0x08:.flush	;0x08 is the offset to our code segment: far jump
.flush:
	ret
.end:

tss_flush:
    mov ax, 0x2B    ;rpl=3
    ltr ax
    ret
